/* (C) 2009-2010,2012 Yana */

#include "device.h"
#include "start_setup.h"
#include "y_base.h"
#include "y_device.h"

y_uint8_t task0_stack[TASK0_STACK_SIZE] __attribute__((aligned(Y_STACK_ALIGNMENT)));

y_uint32_t disk_read(y_uint32_t id, y_uint32_t offset, void *address, y_uint32_t size) {
	y_uint32_t i;
	for (i = 0; i < size; ++i) {
		y_uint32_t a;
		if (i % DEVICE_DISK_BUFFER_LEN == 0) {
			if (size - i >= DEVICE_DISK_BUFFER_LEN) {
				a = 0;
			} else {
				if (DEVICE_DISK_BUFFER_LEN - (size - i) > i + offset) {
					a = i + offset;
				} else {
					a = DEVICE_DISK_BUFFER_LEN - (size - i);
				}
			}
			*(volatile y_uint32_t *)DEVICE_DISK_OFFSET = i + offset - a;
			*(volatile y_uint32_t *)DEVICE_DISK_OFFSET_HIGH32 = 0;
			*(volatile y_uint32_t *)DEVICE_DISK_ID = id;
			*(volatile y_uint32_t *)DEVICE_DISK_START_OPERATION = DEVICE_DISK_OPERATION_READ;
			if (*(volatile y_uint32_t *)DEVICE_DISK_STATUS == 0) {
				return i;
			}
		}
		((y_uint8_t *)address)[i] = ((volatile y_uint8_t *)DEVICE_DISK_BUFFER)[i % DEVICE_DISK_BUFFER_LEN + a];
	}
	return size;
}

#include <minix/sys_config.h>

#include <minix/com.h>
#include <minix/const.h>

#include <compat/a.out.h>

#define NAME_SIZE 64

#if !defined(MINIX_KERNEL) || MINIX_KERNEL % CLICK_SIZE != 0
#error MINIX_KERNEL
#endif

struct exec aout[LAST_SPECIAL_PROC_NR + 2];

void task0(void) {
	y_uint32_t a;
	y_uint32_t i;
	y_uint32_t o;
	y_device_cons_initialize();
	a = MINIX_KERNEL;
	o = 0;
	for (i = 0; i < LAST_SPECIAL_PROC_NR + 2; ++i) {
		o += NAME_SIZE;
		if (disk_read(0, o, &aout[i], sizeof(struct exec)) != sizeof(struct exec)) {
			y_device_cons_put_string("{");
			y_device_cons_put_hexadecimal(o);
			y_device_cons_put_string(" ");
			y_device_cons_put_hexadecimal(sizeof(struct exec));
			y_device_cons_put_string("}\n");
			y_device_cons_halt();
		}
		o += sizeof(struct exec);
		aout[i].a_syms = a;
		if (disk_read(0, o, (void *)a, aout[i].a_text) != aout[i].a_text) {
			y_device_cons_put_string("{");
			y_device_cons_put_hexadecimal(o);
			y_device_cons_put_string(" ");
			y_device_cons_put_hexadecimal(aout[i].a_text);
			y_device_cons_put_string("}\n");
			y_device_cons_halt();
		}
		a += aout[i].a_text;
		o += aout[i].a_text;
		if (disk_read(0, o, (void *)a, aout[i].a_data) != aout[i].a_data) {
			y_device_cons_put_string("{");
			y_device_cons_put_hexadecimal(o);
			y_device_cons_put_string(" ");
			y_device_cons_put_hexadecimal(aout[i].a_data);
			y_device_cons_put_string("}\n");
			y_device_cons_halt();
		}
		a = (a + aout[i].a_total + CLICK_SIZE - 1) / CLICK_SIZE * CLICK_SIZE;
		o += aout[i].a_data;
	}
	((void (*)(void *))aout[0].a_entry)(aout);
}
